Index: c/src/lib/libbsp/mips/genmongoosev/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,13 @@
+Makefile
+Makefile.in
+aclocal.m4
+config.cache
+config.guess
+config.log
+config.status
+config.sub
+configure
+depcomp
+install-sh
+missing
+mkinstalldirs
Index: c/src/lib/libbsp/mips/genmongoosev/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/ChangeLog	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/ChangeLog	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,14 @@
+2001-02-22	Joel Sherrill <joel@OARcorp.com>
+
+	* The Generic Mongoose-V BSP uses only the peripherals found on
+	the Synova Mongoose-V CPU.  This is a radiation hardened CPU 
+	based on the LSI Logic 33K.
+	* .cvsignore, ChangeLog, Makefile.am, README, bsp_specs, configure.in,
+	clock/.cvsignore, clock/Makefile.am, clock/clockdrv.c,
+	console/.cvsignore, console/Makefile.am, console/conscfg.c,
+	include/.cvsignore, include/Makefile.am, include/bsp.h,
+	start/.cvsignore, start/Makefile.am, start/regs.S, start/start.S,
+	startup/.cvsignore, startup/Makefile.am, startup/bspstart.c,
+	startup/linkcmds, timer/.cvsignore, timer/Makefile.am, timer/timer.c,
+	wrapup/.cvsignore, wrapup/Makefile.am: New files.
+
Index: c/src/lib/libbsp/mips/genmongoosev/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,17 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+ACLOCAL_AMFLAGS = -I ../../../../../../aclocal
+
+# wrapup is the one that actually builds and installs the library
+#  from the individual .rel files built in other directories
+SUBDIRS = include start startup clock console timer wrapup
+
+include $(top_srcdir)/../../bsp.am
+
+EXTRA_DIST = bsp_specs times
+
+include $(top_srcdir)/../../../../../../automake/subdirs.am
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/README
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/README	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/README	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,65 @@
+#
+#  $Id$
+#
+
+BSP supporting the on-CPU capabilities of the Synova Mongoose-V.
+This BSP assumes that basic HW initialization is performed by
+PMON.
+
+Address Map
+===========
+This is the generic address map of the Mongoose-V prototyping board
+this BSP was tested on.
+
+0x8000_0000 - 0x8FFF_FFFF   - RAM (KSEG0 cached)
+0xA000_0000 - 0xAFFF_FFFF   - RAM (KSEG1, same memory uncached)
+0xBFC0_0000 - 0xBFFF_FFFF   - EEPROM
+0xFFFE_xxxx                 - on-CPU peripherals
+
+This is the hardware address map of the board used as it was
+actually populated.
+
+0x8000_0000 - 0x83FF_FFFF   - 32 MB RAM (KSEG0 cached)
+0xA000_0000 - 0xA3FF_FFFF   - 32 MB RAM (KSEG1, same memory uncached)
+0xBFC0_0000 - 0xBFDF_FFFF   - 2 MB EEPROM
+0xFFFE_xxxx                 - on-CPU peripherals
+
+This is the organization of the EEPROM when fully populated.  Since
+the board used to develop this BSP only had the first bank of EEPROM
+populated, only the first program image area was used.
+
+0xBFC0_0000 - 0xBFC3_FFFF   - PMON
+0xBFC4_0000 - 0xBFC4_FFFF   - reserved for boot loader
+0xBFC5_0000 - 0xBFDF_FFFF   - reserved for program 1 image
+0xBFE0_0000 - 0xBFFF_FFFF   - reserved for program 2 image
+
+The Mongoose-V on this board is at 12 Mhz.
+
+Downloading
+===========
+
+At startup, PMON looks for a <space> to be pressed.  If it is pressed,
+then a PMON prompt is displayed.  Otherwise, PMON automatically jumps
+to the code at 0xBFC4_0000.  This code may be a boot manager or
+simply a collection of noop's that fall into the code at 
+0xBFC5_0000.  If the code at 0xBFC4_0000 is a boot manager, then it
+can determine which program image to load.  This layout allows for the
+possible compression of program images.  Given that there is much
+more RAM than EEPROM, compression could be desirable for certain
+applications.
+
+Questions
+=========
+
++  XXX
+ 
+Status
+======
+
++ untested
+
++ no mkeeprom script
+
++ start code must copy from EEPROM to RAM and then run.
+
++ XXX
Index: c/src/lib/libbsp/mips/genmongoosev/bsp_specs
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/bsp_specs	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/bsp_specs	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,23 @@
+%rename cpp old_cpp
+%rename lib old_lib
+%rename endfile old_endfile
+%rename startfile old_startfile
+%rename link old_link
+
+*cpp:
+%(old_cpp) %{qrtems: -D__embedded__} -Asystem(embedded)
+
+*lib:
+%{!qrtems: %(old_lib)} %{qrtems: --start-group \
+%{!qrtems_debug: -lrtemsall} %{qrtems_debug: -lrtemsall_g} \
+-lc -lgcc --end-group \
+%{!qnolinkcmds: -T linkcmds%s}}
+
+*startfile:
+%{!qrtems: %(old_startfile)} %{qrtems: \
+%{!qrtems_debug: start.o%s} \
+%{qrtems_debug: start_g.o%s}}
+
+*link:
+%(old_link) %{!qrtems: %(old_link)} %{qrtems: -dc -dp -N -e _start}
+
Index: c/src/lib/libbsp/mips/genmongoosev/clock/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/clock/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/clock/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/clock/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/clock/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,36 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/clock.rel
+
+C_FILES = clockdrv.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+# to include the shared clock driver shell
+AM_CPPFLAGS += -I$(top_srcdir)/../../shared
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = clockdrv.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/clock/clockdrv.c
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/clock/clockdrv.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/clock/clockdrv.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,54 @@
+/*
+ *  Instantiate the clock driver shell.
+ *
+ *  The tx3904 simulator in gdb counts instructions.
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include <libcpu/mongoose-v.h>
+#include <bsp.h>
+
+#if defined(USE_TIMER2_FOR_CLOCK)
+#define CLOCK_BASE   MONGOOSEV_TIMER2_BASE
+#define CLOCK_VECTOR MONGOOSEV_IRQ_TIMER2
+#else
+#define CLOCK_BASE   MONGOOSEV_TIMER1_BASE
+#define CLOCK_VECTOR MONGOOSEV_IRQ_TIMER1
+#endif
+
+/* reset Timeout (TO) bit */
+#define Clock_driver_support_at_tick() \
+  MONGOOSEV_WRITE_REGISTER( \
+    CLOCK_BASE, \
+    MONGOOSEV_TIMER_CONTROL_REGISTER, \
+    (MONGOOSEV_TIMER_CONTROL_COUNTER_ENABLE | \
+     MONGOOSEV_TIMER_CONTROL_INTERRUPT_ENABLE) \
+  );
+
+#define Clock_driver_support_install_isr( _new, _old ) \
+  do { \
+    _old = set_vector( _new, CLOCK_VECTOR, 1 ); \
+  } while(0)
+
+
+extern int ClockRate;
+
+#define CLICKS (unsigned32) &ClockRate
+#define Clock_driver_support_initialize_hardware() \
+  do { \
+    unsigned32 _clicks; \
+    _clicks = CLICKS * rtems_configuration_get_microseconds_per_tick(); \
+    MONGOOSEV_WRITE_REGISTER( \
+      CLOCK_BASE, \
+      MONGOOSEV_TIMER_INITIAL_COUNTER_REGISTER, \
+      _clicks \
+    ); \
+    Clock_driver_support_at_tick(); \
+  } while(0)
+
+#define Clock_driver_support_shutdown_hardware() \
+  MONGOOSEV_WRITE_REGISTER( CLOCK_BASE, MONGOOSEV_TIMER_CONTROL_REGISTER, 0 )
+
+#include <clockdrv_shell.c>
Index: c/src/lib/libbsp/mips/genmongoosev/configure.in
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/configure.in	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/configure.in	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,36 @@
+dnl Process this file with autoconf to produce a configure script.
+dnl
+dnl $Id$
+
+AC_PREREQ(2.13)
+AC_INIT(bsp_specs)
+RTEMS_TOP(../../../../../..)
+AC_CONFIG_AUX_DIR(../../../../../..)
+
+RTEMS_CANONICAL_TARGET_CPU
+AM_INIT_AUTOMAKE(rtems-c-src-lib-libbsp-mips-genmongoosev,$RTEMS_VERSION,no)
+
+AM_MAINTAINER_MODE
+
+RTEMS_PROG_CC_FOR_TARGET
+RTEMS_CANONICALIZE_TOOLS
+
+RTEMS_ENV_RTEMSBSP
+RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
+RTEMS_CHECK_BSP_CACHE(RTEMS_BSP)
+RTEMS_CANONICAL_HOST
+
+RTEMS_PROJECT_ROOT
+
+# Explicitly list all Makefiles here
+AC_OUTPUT( 
+Makefile
+clock/Makefile
+console/Makefile
+include/Makefile
+start/Makefile
+startup/Makefile
+timer/Makefile
+wrapup/Makefile)
+
+RTEMS_OUTPUT_BUILD_SUBDIRS(RTEMS_BUILD_SUBDIRS)
Index: c/src/lib/libbsp/mips/genmongoosev/console/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/console/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/console/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/console/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/console/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,35 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+VPATH = @srcdir@:@srcdir@/../../../shared
+
+PGM = $(ARCH)/console.rel
+
+C_FILES = conscfg.c console.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = conscfg.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/console/conscfg.c
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/console/conscfg.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/console/conscfg.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,77 @@
+/*
+ *  This file contains the libchip configuration information
+ *  to instantiate the libchip driver for the on-CPU DUART
+ *  and any other serial ports in the system.
+ *
+ *
+ *  COPYRIGHT (c) 1989-2001.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <bsp.h> 
+ 
+#include <libchip/serial.h>
+#include <libchip/mg5uart.h>
+
+#if (CONSOLE_USE_INTERRUPTS)
+#define MG5UART_FUNCTIONS &mg5uart_fns
+#else
+#define MG5UART_FUNCTIONS &mg5uart_fns_polled
+#endif
+
+extern int ClockRate;
+#define CLOCK_RATE (unsigned32) &ClockRate
+
+console_tbl     Console_Port_Tbl[] = {
+{
+  "/dev/com0",                            /* sDeviceName */
+   SERIAL_MG5UART,                         /* deviceType */
+   MG5UART_FUNCTIONS,                      /* pDeviceFns */
+   NULL,                                   /* deviceProbe, assume it is there */
+   NULL,                                   /* pDeviceFlow */
+   16,                                     /* ulMargin */
+   8,                                      /* ulHysteresis */
+   (void *) NULL,               /* NULL */ /* pDeviceParams */
+   MONGOOSEV_PERIPHERAL_COMMAND_REGISTER,  /* ulCtrlPort1 */
+   MONGOOSEV_UART0_BASE,                   /* ulCtrlPort2 */
+   MG5UART_UART0,                          /* ulDataPort */
+   NULL,                                   /* getRegister */
+   NULL,                                   /* setRegister */
+   NULL, /* unused */                      /* getData */
+   NULL, /* unused */                      /* setData */
+   CLOCK_RATE,                             /* ulClock */
+   MONGOOSEV_IRQ_UART0_RX_FRAME_ERROR      /* ulIntVector -- base for port */
+}
+};
+
+/*
+ *  Declare some information used by the console driver
+ */
+
+#define NUM_CONSOLE_PORTS (sizeof(Console_Port_Tbl)/sizeof(console_tbl))
+
+unsigned long  Console_Port_Count = NUM_CONSOLE_PORTS;
+
+console_data  Console_Port_Data[NUM_CONSOLE_PORTS];
+
+rtems_device_minor_number  Console_Port_Minor;
+
+
+/*
+ *  printk() support that simply routes printk to stderr
+ */
+
+#include <bspIo.h>
+
+void GENMG5_output_char(char c) { write( 2, &c, 1 ); }
+  
+BSP_output_char_function_type           BSP_output_char = GENMG5_output_char;
+BSP_polling_getchar_function_type       BSP_poll_char = NULL;
+   
+
Index: c/src/lib/libbsp/mips/genmongoosev/include/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/include/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/include/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/include/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/include/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/include/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,25 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+H_FILES = bsp.h ../../../shared/include/coverhd.h
+
+$(PROJECT_INCLUDE):
+	$(mkinstalldirs) $@
+
+$(PROJECT_INCLUDE)/bsp.h: bsp.h
+	$(INSTALL_DATA) $< $@
+
+$(PROJECT_INCLUDE)/coverhd.h: ../../../shared/include/coverhd.h
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_INCLUDE) $(PROJECT_INCLUDE)/bsp.h \
+    $(PROJECT_INCLUDE)/coverhd.h
+
+all-local: $(TMPINSTALL_FILES)
+
+EXTRA_DIST = bsp.h
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/include/bsp.h
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/include/bsp.h	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/include/bsp.h	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,106 @@
+/*  bsp.h
+ *
+ *  This include file contains some definitions specific to a board
+ *  based upon the generic capabilities of a Mongoose-V.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#ifndef __GENERIC_MONGOOSE_V_h
+#define __GENERIC_MONGOOSE_V_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <rtems.h>
+#include <iosupp.h>
+#include <console.h>
+#include <clockdrv.h>
+#include <libcpu/mongoose-v.h>
+
+/*
+ *  Define the time limits for RTEMS Test Suite test durations.
+ *  Long test and short test duration limits are provided.  These
+ *  values are in seconds and need to be converted to ticks for the
+ *  application.
+ *
+ */
+
+#define MAX_LONG_TEST_DURATION       300 /* 5 minutes = 300 seconds */
+#define MAX_SHORT_TEST_DURATION      3   /* 3 seconds */
+
+/*
+ *  Define the interrupt mechanism for Time Test 27
+ *
+ *  NOTE: Following are for XXX and are board independent
+ *
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#if 0
+#define Install_tm27_vector( handler ) \
+    (void) set_vector( handler, MONGOOSEV_IRQ_SOFTWARE_1, 1 ); \
+
+#define Cause_tm27_intr() \
+    asm volatile ( "syscall 0x01" : : );
+
+#define CLOCK_VECTOR MONGOOSEV_IRQ_TMR0
+
+#define Clear_tm27_intr()  
+
+#define Lower_tm27_intr()
+#else
+#define Install_tm27_vector( handler ) \
+    (void) set_vector( handler, MONGOOSEV_IRQ_TMR0, 1 ); \
+
+#define Cause_tm27_intr() \
+  do { \
+    ; \
+  } while(0)
+
+#define Clear_tm27_intr() 
+
+#define Lower_tm27_intr()
+
+#endif
+
+/* Constants */
+
+/* miscellaneous stuff assumed to exist */
+
+extern rtems_configuration_table BSP_Configuration;
+
+/*
+ *  Device Driver Table Entries
+ */
+
+/*
+ * NOTE: Use the standard Console driver entry
+ */
+ 
+/*
+ * NOTE: Use the standard Clock driver entry
+ */
+
+/* functions */
+
+void bsp_cleanup( void );
+
+rtems_isr_entry set_vector(
+  rtems_isr_entry, rtems_vector_number, int );
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+/* end of include file */
Index: c/src/lib/libbsp/mips/genmongoosev/start/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/start/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/start/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/start/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/start/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,33 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/start.o
+
+S_FILES = start.S
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+
+OBJS = $(S_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).o: $(PGM)
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).o
+
+all-local: $(ARCH) $(OBJS) $(PGM) $(TMPINSTALL_FILES)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = start.S
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/start/regs.S
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/start/regs.S	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/start/regs.S	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,138 @@
+/*
+ * regs.S -- standard MIPS register names from
+ * newlib-1.8.2/libgloss/mips and adapted.
+ *
+ * Copyright (c) 1995 Cygnus Support
+ *
+ * The authors hereby grant permission to use, copy, modify, distribute,
+ * and license this software and its documentation for any purpose, provided
+ * that existing copyright notices are retained in all copies and that this
+ * notice is included verbatim in any distributions. No written agreement,
+ * license, or royalty fee is required for any of the authorized uses.
+ * Modifications to this software may be copyrighted by their authors
+ * and need not follow the licensing terms described here, provided that
+ * the new terms are clearly indicated on the first page of each file where
+ * they apply.
+ */
+
+/* Standard MIPS register names: */
+#define zero	$0
+#define z0	$0
+#define v0	$2
+#define v1	$3
+#define a0	$4
+#define a1	$5
+#define a2	$6
+#define a3	$7
+#define t0	$8
+#define t1	$9
+#define t2	$10
+#define t3	$11
+#define t4	$12
+#define t5	$13
+#define t6	$14
+#define t7	$15
+#define s0	$16
+#define s1	$17
+#define s2	$18
+#define s3	$19
+#define s4	$20
+#define s5	$21
+#define s6	$22
+#define s7	$23
+#define t8	$24
+#define t9	$25
+#define k0	$26	/* kernel private register 0 */
+#define k1	$27	/* kernel private register 1 */
+#define gp	$28	/* global data pointer */
+#define sp 	$29	/* stack-pointer */
+#define fp	$30	/* frame-pointer */
+#define ra	$31	/* return address */
+#define pc	$pc	/* pc, used on mips16 */
+
+#define fp0	$f0
+#define fp1	$f1
+
+/* Useful memory constants: */
+#define K0BASE		0x80000000
+#ifndef __mips64
+#define K1BASE		0xA0000000
+#else
+#define K1BASE		0xFFFFFFFFA0000000LL
+#endif
+
+#define PHYS_TO_K1(a)   ((unsigned)(a) | K1BASE)
+
+/* Standard Co-Processor 0 register numbers:
+#define C0_COUNT	$9		/* Count Register */
+#define C0_SR		$12		/* Status Register */
+#define C0_CAUSE	$13		/* last exception description */
+#define C0_EPC		$14		/* Exception error address */
+#define C0_CONFIG	$16		/* CPU configuration */
+
+/* Standard Status Register bitmasks: */
+#define SR_CU1		0x20000000	/* Mark CP1 as usable */
+#define SR_FR		0x04000000	/* Enable MIPS III FP registers */
+#define SR_BEV		0x00400000	/* Controls location of exception vectors */
+#define SR_PE		0x00100000	/* Mark soft reset (clear parity error) */
+
+#define SR_KX		0x00000080	/* Kernel extended addressing enabled */
+#define SR_SX		0x00000040	/* Supervisor extended addressing enabled */
+#define SR_UX		0x00000020	/* User extended addressing enabled */
+
+/* Standard (R4000) cache operations. Taken from "MIPS R4000
+   Microprocessor User's Manual" 2nd edition: */
+
+#define CACHE_I		(0)	/* primary instruction */
+#define CACHE_D		(1)	/* primary data */
+#define CACHE_SI	(2)	/* secondary instruction */
+#define CACHE_SD	(3)	/* secondary data (or combined instruction/data) */
+
+#define INDEX_INVALIDATE		(0)	/* also encodes WRITEBACK if CACHE_D or CACHE_SD */
+#define INDEX_LOAD_TAG			(1)
+#define INDEX_STORE_TAG			(2)
+#define CREATE_DIRTY_EXCLUSIVE		(3)	/* CACHE_D and CACHE_SD only */
+#define HIT_INVALIDATE			(4)
+#define CACHE_FILL			(5)	/* CACHE_I only */
+#define HIT_WRITEBACK_INVALIDATE	(5)	/* CACHE_D and CACHE_SD only */
+#define HIT_WRITEBACK			(6)	/* CACHE_I, CACHE_D and CACHE_SD only */
+#define HIT_SET_VIRTUAL			(7)	/* CACHE_SI and CACHE_SD only */
+
+#define BUILD_CACHE_OP(o,c)		(((o) << 2) | (c))
+
+/* Individual cache operations: */
+#define INDEX_INVALIDATE_I		BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_I)
+#define INDEX_WRITEBACK_INVALIDATE_D	BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_D)
+#define INDEX_INVALIDATE_SI             BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_SI)
+#define INDEX_WRITEBACK_INVALIDATE_SD	BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_SD)
+
+#define INDEX_LOAD_TAG_I		BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_I)
+#define INDEX_LOAD_TAG_D                BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_D)
+#define INDEX_LOAD_TAG_SI               BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_SI)
+#define INDEX_LOAD_TAG_SD               BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_SD)
+
+#define INDEX_STORE_TAG_I              	BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_I)
+#define INDEX_STORE_TAG_D               BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_D)
+#define INDEX_STORE_TAG_SI              BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_SI)
+#define INDEX_STORE_TAG_SD              BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_SD)
+
+#define CREATE_DIRTY_EXCLUSIVE_D        BUILD_CACHE_OP(CREATE_DIRTY_EXCLUSIVE,CACHE_D)
+#define CREATE_DIRTY_EXCLUSIVE_SD       BUILD_CACHE_OP(CREATE_DIRTY_EXCLUSIVE,CACHE_SD)
+
+#define HIT_INVALIDATE_I                BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_I)
+#define HIT_INVALIDATE_D                BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_D)
+#define HIT_INVALIDATE_SI               BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_SI)
+#define HIT_INVALIDATE_SD               BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_SD)
+
+#define CACHE_FILL_I                    BUILD_CACHE_OP(CACHE_FILL,CACHE_I)
+#define HIT_WRITEBACK_INVALIDATE_D      BUILD_CACHE_OP(HIT_WRITEBACK_INVALIDATE,CACHE_D)
+#define HIT_WRITEBACK_INVALIDATE_SD     BUILD_CACHE_OP(HIT_WRITEBACK_INVALIDATE,CACHE_SD)
+
+#define HIT_WRITEBACK_I                 BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_I)
+#define HIT_WRITEBACK_D                 BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_D)
+#define HIT_WRITEBACK_SD                BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_SD)
+
+#define HIT_SET_VIRTUAL_SI		BUILD_CACHE_OP(HIT_SET_VIRTUAL,CACHE_SI)
+#define HIT_SET_VIRTUAL_SD              BUILD_CACHE_OP(HIT_SET_VIRTUAL,CACHE_SD)
+
+/*> EOF regs.S <*/
Index: c/src/lib/libbsp/mips/genmongoosev/start/start.S
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/start/start.S	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/start/start.S	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,231 @@
+/*
+ * start.S -- startup file for JMR3904 BSP based upon crt0.S from
+ * newlib-1.8.2/libgloss/mips and adapted for RTEMS.
+ *
+ * crt0.S -- startup file for MIPS.
+ *
+ * Copyright (c) 1995, 1996, 1997 Cygnus Support
+ *
+ * The authors hereby grant permission to use, copy, modify, distribute,
+ * and license this software and its documentation for any purpose, provided
+ * that existing copyright notices are retained in all copies and that this
+ * notice is included verbatim in any distributions. No written agreement,
+ * license, or royalty fee is required for any of the authorized uses.
+ * Modifications to this software may be copyrighted by their authors
+ * and need not follow the licensing terms described here, provided that
+ * the new terms are clearly indicated on the first page of each file where
+ * they apply.
+ */
+
+#ifdef __mips16
+/* This file contains 32 bit assembly code.  */
+	.set nomips16
+#endif
+
+#include <asm.h>
+#include "regs.S"
+
+/*
+ * Set up some room for a stack. We just grab a chunk of memory.
+ */
+#define STACK_SIZE  0x4000
+#define GLOBAL_SIZE 0x2000
+
+#define STARTUP_STACK_SIZE	0x0100
+
+/* This is for referencing addresses that are not in the .sdata or
+   .sbss section under embedded-pic, or before we've set up gp.  */
+#ifdef __mips_embedded_pic
+# ifdef __mips64
+#  define LA(t,x) la t,x-PICBASE ; daddu t,s0,t
+# else
+#  define LA(t,x) la t,x-PICBASE ; addu t,s0,t
+# endif
+#else /* __mips_embedded_pic */ 
+# define LA(t,x) la t,x
+#endif /* __mips_embedded_pic */ 
+
+	.comm	__memsize, 12
+	.comm	__lstack, STARTUP_STACK_SIZE
+	.comm   __stackbase,4
+
+	.text
+	.align	2
+
+/* Without the following nop, GDB thinks _start is a data variable.
+ * This is probably a bug in GDB in handling a symbol that is at the
+ * start of the .text section.
+ */
+	nop
+
+	.globl	_start
+	.ent	_start
+_start:
+	.set	noreorder
+#ifdef __mips_embedded_pic
+	PICBASE = .+8
+        bal	PICBASE
+	nop
+	move	s0,$31
+#endif
+
+	li	v0, SR_CU1|SR_PE|SR_FR|SR_KX|SR_SX|SR_UX
+	mtc0	v0, C0_SR
+	mtc0	zero, C0_CAUSE
+
+/* Check for FPU presence */
+#ifndef __mips_soft_float
+/* This doesn't work if there is no FPU.  We get illegal instruction
+   exceptions.  */
+	li	t2,0xAAAA5555
+	mtc1	t2,fp0		/* write to FPR 0 */
+	mtc1	zero,fp1	/* write to FPR 1 */
+	mfc1	t0,fp0
+	mfc1	t1,fp1
+	nop
+	bne	t0,t2,1f	/* check for match */
+	nop
+	bne	t1,zero,1f	/* double check */
+	nop
+#ifndef __mips64  /* Clear the FR bit */
+	li	v0, SR_CU1|SR_PE|SR_KX|SR_SX|SR_UX
+	mtc0	v0, C0_SR
+#endif
+	j	2f
+	nop
+#endif
+1:
+	li	v0, SR_PE|SR_FR|SR_KX|SR_SX|SR_UX
+	mtc0	v0, C0_SR
+2:
+/* Fix high bits, if any, of the PC so that exception handling 
+   doesn't get confused.  */
+	LA (v0, 3f)
+	jr	v0
+	nop
+3:
+	LA (gp, _gp)				# set the global data pointer
+	.end _start
+
+/*
+ * zero out the bss section.
+ */
+	.globl	__memsize
+	.globl	get_mem_info .text
+	.globl	__stack
+	.globl	__global
+	.globl	zerobss
+	.ent	zerobss
+zerobss:
+	LA (v0, _fbss)
+	LA (v1, _end)
+3:
+	sw	zero,0(v0)
+	bltu	v0,v1,3b
+	addiu	v0,v0,4				# executed in delay slot
+
+	la	t0, __lstack			# make a small stack so we
+	addiu	sp, t0, STARTUP_STACK_SIZE	# can run some C code
+	la	a0, __memsize			# get the usable memory size
+	jal	get_mem_info
+	nop
+
+	/* setup the stack pointer */
+	LA (t0, __stack)			# is __stack set ?
+	bne	t0,zero,4f
+	nop
+
+	/* NOTE: a0[0] contains the amount of memory available, and
+	         not the last memory address. */
+	lw	t0,0(a0)			# last address of memory available
+	la	t1,K0BASE			# cached kernel memory
+	addu	t0,t0,t1			# get the end of memory address
+	/* We must subtract 24 bytes for the 3 8 byte arguments to main, in
+	   case main wants to write them back to the stack.  The caller is
+	   supposed to allocate stack space for parameters in registers in
+	   the old MIPS ABIs.  We must do this even though we aren't passing
+	   arguments, because main might be declared to have them. 
+
+	   Some ports need a larger alignment for the stack, so we subtract
+	   32, which satisifes the stack for the arguments and keeps the
+	   stack pointer better aligned.  */
+	subu	t0,t0,32			# and generate a starting stack-pointer
+4:
+	move	sp,t0				# set stack pointer
+	sw	sp,__stackbase			# keep this for future ref
+	.end	zerobss
+
+/*
+ * initialize target specific stuff. Only execute these
+ * functions it they exist.
+ */
+#if 0
+	.globl	hardware_init_hook .text
+	.globl	software_init_hook .text
+	.globl	__do_global_dtors .text
+	.globl	atexit .text
+#endif
+	.globl	exit .text
+	.globl	init
+	.ent	init
+init:
+#if 0
+	LA (t9, hardware_init_hook)		# init the hardware if needed
+	beq	t9,zero,6f
+	nop
+	jal	t9
+	nop
+6:
+	LA (t9, software_init_hook)		# init the hardware if needed
+	beq	t9,zero,7f
+	nop
+	jal	t9
+	nop
+7:
+	LA (a0, __do_global_dtors)
+	jal	atexit
+	nop
+#endif
+
+#ifdef GCRT0
+	.globl	_ftext
+	.globl	_extext
+	LA (a0, _ftext)
+	LA (a1, _etext)
+	jal	monstartup
+	nop
+#endif
+
+	move	a0,zero				# set argc to 0
+	jal	boot_card			# call the program start function
+	nop
+
+	# fall through to the "exit" routine
+	jal	exit				# call libc exit to run the G++
+						# destructors
+	move	a0,v0				# pass through the exit code
+	.end	init
+	
+/*
+ *  Exit from the application. Normally we cause a user trap
+ *  to return to the ROM monitor for another run. NOTE: This is
+ *  the only other routine we provide in the crt0.o object, since
+ *  it may be tied to the "_start" routine. It also allows
+ *  executables that contain a complete world to be linked with
+ *  just the crt0.o object.
+ */
+
+FRAME(_sys_exit,sp,0,ra)
+7:
+#ifdef GCRT0
+	jal	_mcleanup
+	nop
+#endif
+	# break instruction can cope with 0xfffff, but GAS limits the range:
+	break	1023
+	nop
+	b	7b				# but loop back just in-case
+	nop
+ENDFRAME(_sys_exit)
+
+/* EOF crt0.S */
Index: c/src/lib/libbsp/mips/genmongoosev/startup/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/startup/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/startup/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/startup/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/startup/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,40 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+VPATH = @srcdir@:@srcdir@/../../../shared
+
+PGM = $(ARCH)/startup.rel
+
+C_FILES = bspclean.c bsplibc.c bsppost.c bspstart.c bootcard.c main.c sbrk.c \
+    gnatinstallhandler.c setvec.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+$(PROJECT_RELEASE)/lib/linkcmds: linkcmds
+	$(INSTALL_DATA) $< $@
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/linkcmds
+
+all-local: $(ARCH) $(OBJS) $(PGM) $(TMPINSTALL_FILES)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = bspclean.c bspstart.c exit.c linkcmds setvec.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/startup/bspstart.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/startup/bspstart.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,122 @@
+/*
+ *  This routine starts the application.  It includes application,
+ *  board, and monitor specific initialization and configuration.
+ *  The generic CPU dependent initialization has been performed
+ *  before this routine is invoked.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <string.h>
+
+#include <bsp.h>
+#include <rtems/libio.h>
+#include <rtems/libcsupport.h>
+
+/*
+ *  The original table from the application and our copy of it with
+ *  some changes.
+ */
+
+extern rtems_configuration_table Configuration;
+
+rtems_configuration_table  BSP_Configuration;
+
+rtems_cpu_table Cpu_table;
+
+char *rtems_progname;
+
+/*
+ *  Use the shared implementations of the following routines
+ */
+ 
+void bsp_postdriver_hook(void);
+void bsp_libc_init( void *, unsigned32, int );
+
+/*
+ *  Function:   bsp_pretasking_hook
+ *  Created:    95/03/10
+ *
+ *  Description:
+ *      BSP pretasking hook.  Called just before drivers are initialized.
+ *      Used to setup libc and install any BSP extensions.
+ *
+ *  NOTES:
+ *      Must not use libc (to do io) from here, since drivers are
+ *      not yet initialized.
+ *
+ */
+ 
+void bsp_pretasking_hook(void)
+{
+    extern int HeapBase;
+    extern int HeapSize;
+    void         *heapStart = &HeapBase;
+    unsigned long heapSize = (unsigned long)&HeapSize;
+    unsigned long ramSpace;
+
+    bsp_libc_init(heapStart, (unsigned32) heapSize, 0);
+
+#ifdef RTEMS_DEBUG
+    rtems_debug_enable( RTEMS_DEBUG_ALL_MASK );
+#endif
+
+}
+ 
+/*
+ *  bsp_start
+ *
+ *  This routine does the bulk of the system initialization.
+ */
+
+void bsp_start( void )
+{
+  extern int _end;
+  extern int WorkspaceBase;
+  /* Configure Number of Register Caches */
+
+  Cpu_table.pretasking_hook = bsp_pretasking_hook;  /* init libc, etc. */
+  Cpu_table.postdriver_hook = bsp_postdriver_hook;
+  Cpu_table.interrupt_stack_size = 4096;
+
+  /* HACK -- tied to value linkcmds */
+  if ( BSP_Configuration.work_space_size >(4096*1024) )
+   _sys_exit( 1 );
+
+  BSP_Configuration.work_space_start = (void *) &WorkspaceBase;
+
+  mips_set_sr( 0xff00 );  /* all interrupts unmasked but globally off */
+                          /* depend on the IRC to take care of things */
+  mips_install_isr_entries();
+}
+
+/* XXX */
+void clear_cache( void *address, size_t n )
+{
+}
+
+/* Structure filled in by get_mem_info.  Only the size field is
+   actually used (to clear bss), so the others aren't even filled in.  */
+
+struct s_mem
+{
+  unsigned int size;
+  unsigned int icsize;
+  unsigned int dcsize;
+};
+
+
+void
+get_mem_info (mem)
+     struct s_mem *mem;
+{
+  mem->size = 0x1000000;        /* XXX figure out something here */
+}
+
Index: c/src/lib/libbsp/mips/genmongoosev/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/startup/linkcmds	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/startup/linkcmds	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,157 @@
+/*
+ *  Linker script for Mongoose-V prototyping board.
+ *  See README for address map details.
+ *
+ *  $Id$
+ */
+
+/*
+ * Declare some sizes.
+ */
+_RamBase = DEFINED(_RamBase) ? _RamBase : 0x80000000;
+_RamSize = DEFINED(_RamSize) ? _RamSize : 32M;
+HeapSize = DEFINED(HeapSize) ? HeapSize : 0x10000;
+_StackSize = DEFINED(_StackSize) ? _StackSize : 0x1000;
+ClockRate = DEFINED(ClockRate) ? ClockRate : 12000000;
+
+SECTIONS
+{ 
+    . = 0x80000000;
+    .text : 
+    { 
+       _ftext = . ;
+      *(.init)
+       eprol  =  .;
+      *(.text)
+      *(.text.*)
+      *(.gnu.linkonce.t*)
+      *(.mips16.fn.*)
+      *(.mips16.call.*)
+      PROVIDE (__runtime_reloc_start = .);
+      *(.rel.sdata)
+      PROVIDE (__runtime_reloc_stop = .);
+      *(.fini)
+       etext  =  .;
+       _etext  =  .;
+    }  
+  .ctors    :
+  {
+    /* gcc uses crtbegin.o to find the start of
+       the constructors, so we make sure it is
+       first.  Because this is a wildcard, it
+       doesn't matter if the user does not
+       actually link against crtbegin.o; the
+       linker won't look for a file to match a
+       wildcard.  The wildcard also means that it
+       doesn't matter which directory crtbegin.o
+       is in.  */
+
+    KEEP (*crtbegin.o(.ctors))
+
+    /* We don't want to include the .ctor section from
+       from the crtend.o file until after the sorted ctors.
+       The .ctor section from the crtend file contains the
+       end of ctors marker and it must be last */
+
+    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
+    KEEP (*(SORT(.ctors.*)))
+    KEEP (*(.ctors))
+  }
+
+  .dtors    :
+  {
+    KEEP (*crtbegin.o(.dtors))
+    KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
+    KEEP (*(SORT(.dtors.*)))
+    KEEP (*(.dtors))
+  }
+
+    . = .;
+  .rdata : {
+    *(.rdata)
+    *(.rodata)
+    *(.rodata.*)
+    *(.gnu.linkonce.r*)
+  }
+   _fdata = ALIGN(16);
+  .data : {
+    *(.data)
+    *(.data.*)
+    *(.gnu.linkonce.d*)
+  }
+  . = ALIGN(8);
+  _gp = . + 0x8000;
+  __global = _gp;
+  .lit8 : {
+    *(.lit8)
+  }
+  .lit4 : {
+    *(.lit4)
+  }
+  .sdata : {
+    *(.sdata)
+    *(.sdata.*)
+    *(.gnu.linkonce.s*)
+  }
+  . = ALIGN(4);
+   edata  =  .;
+   _edata  =  .;
+   _fbss = .;
+  .sbss : {
+    *(.sbss)
+    *(.scommon)
+  }
+  .bss : {
+    _bss_start = . ;
+    *(.bss)
+    *(COMMON)
+    . = ALIGN (64);
+    _stack_limit = .;
+    . += _StackSize;
+    __stack = .;
+    _stack_init = .;
+    _clear_end = .;
+    WorkspaceBase = .;
+     /* HACK -- tied to value bspstart */
+    . += 4096K;    /* reserve some memory for workspace */
+    HeapBase = .;
+    . += HeapSize;    /* reserve some memory for heap */
+  }
+ end = .;
+ _end = .;
+
+
+/* Put starting stack in SRAM (8 Kb); this size is the same as the stack from
+      the original script (when everything was in SRAM). */
+   /* __stack = 0x8000A000; */
+  /* DWARF debug sections.
+     Symbols in the DWARF debugging sections are relative to
+     the beginning of the section so we begin them at 0.  */
+
+  /* DWARF 1 */
+  .debug          0 : { *(.debug) }
+  .line           0 : { *(.line) }
+
+  /* GNU DWARF 1 extensions */
+  .debug_srcinfo  0 : { *(.debug_srcinfo) }
+  .debug_sfnames  0 : { *(.debug_sfnames) }
+
+  /* DWARF 1.1 and DWARF 2 */
+  .debug_aranges  0 : { *(.debug_aranges) }
+  .debug_pubnames 0 : { *(.debug_pubnames) }
+
+  /* DWARF 2 */
+  .debug_info     0 : { *(.debug_info) }
+  .debug_abbrev   0 : { *(.debug_abbrev) }
+  .debug_line     0 : { *(.debug_line) }
+  .debug_frame    0 : { *(.debug_frame) }
+  .debug_str      0 : { *(.debug_str) }
+  .debug_loc      0 : { *(.debug_loc) }
+  .debug_macinfo  0 : { *(.debug_macinfo) }
+
+  /* SGI/MIPS DWARF 2 extensions */
+  .debug_weaknames 0 : { *(.debug_weaknames) }
+  .debug_funcnames 0 : { *(.debug_funcnames) }
+  .debug_typenames 0 : { *(.debug_typenames) }
+  .debug_varnames  0 : { *(.debug_varnames) }
+}
Index: c/src/lib/libbsp/mips/genmongoosev/timer/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/timer/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/timer/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/timer/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/timer/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/timer/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,33 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/timer.rel
+
+C_FILES = timer.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = timer.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/mips/genmongoosev/timer/timer.c
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/timer/timer.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/timer/timer.c	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,95 @@
+/* 
+ *  This file implements a benchmark timer using a MONGOOSE-V timer.
+ *
+ *  NOTE: On the simulator, the count directly reflects instructions.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <assert.h>
+
+#include <bsp.h>
+
+rtems_boolean Timer_driver_Find_average_overhead;
+
+#if defined(USE_TIMER2_FOR_CLOCK)
+#define TIMER_BASE   MONGOOSEV_TIMER1_BASE
+#define TIMER_VECTOR MONGOOSEV_IRQ_TIMER1
+#else
+#define TIMER_BASE   MONGOOSEV_TIMER2_BASE
+#define TIMER_VECTOR MONGOOSEV_IRQ_TIMER2
+#endif
+
+void Timer_initialize()
+{
+  /*
+   *  Programming the compare register as the maximum value should let
+   *  it run long enough and accurate enough not to require an interrupt.
+   *  but if it ever does generate an interrupt, we will simply fault.
+   *
+   *  NOTE:  This is similar to the clock driver initialization
+   *         with the exception that the divider is disabled and
+   *         the compare register is set to the maximum value.
+   */
+
+  MONGOOSEV_WRITE_REGISTER(
+    TIMER_BASE,
+    MONGOOSEV_TIMER_INITIAL_COUNTER_REGISTER,
+    0xffffffff
+  );
+  MONGOOSEV_WRITE_REGISTER(
+    TIMER_BASE,
+    MONGOOSEV_TIMER_CONTROL_REGISTER,
+    MONGOOSEV_TIMER_CONTROL_COUNTER_ENABLE
+  );
+}
+
+#define AVG_OVERHEAD      0  /* It typically takes N instructions */
+                             /*     to start/stop the timer. */
+#define LEAST_VALID       1  /* Don't trust a value lower than this */
+                             /* mongoose-v can count cycles. :) */
+#include <bspIo.h>
+
+int Read_timer()
+{
+  rtems_unsigned32  clicks;
+  rtems_unsigned32  total;
+  rtems_unsigned32  tcr;
+
+  clicks = MONGOOSEV_READ_REGISTER(
+    TIMER_BASE,
+    MONGOOSEV_TIMER_INITIAL_COUNTER_REGISTER
+  );
+  total = 0xffffffff - clicks;
+
+  tcr = MONGOOSEV_READ_REGISTER( TIMER_BASE, MONGOOSEV_TIMER_CONTROL_REGISTER );
+  if ( tcr & MONGOOSEV_TIMER_CONTROL_TIMEOUT )
+    printk( "MG5 timer overran\n" );
+
+  if ( Timer_driver_Find_average_overhead == 1 )
+    return total;          /* in cycle units */
+
+  if ( total < LEAST_VALID )
+    return 0;            /* below timer resolution */
+
+  return total - AVG_OVERHEAD;
+}
+
+rtems_status_code Empty_function( void )
+{
+  return RTEMS_SUCCESSFUL;
+}
+
+void Set_find_average_overhead(
+  rtems_boolean find_flag
+)
+{
+  Timer_driver_Find_average_overhead = find_flag;
+}
Index: c/src/lib/libbsp/mips/genmongoosev/wrapup/.cvsignore
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/wrapup/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/wrapup/.cvsignore	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/mips/genmongoosev/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/genmongoosev/wrapup/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
+++ c/src/lib/libbsp/mips/genmongoosev/wrapup/Makefile.am	(revision f849f3ee1f41b9298d840bc79c1e7be4cc4a6249)
@@ -0,0 +1,36 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+BSP_FILES = startup clock console timer
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+# bummer; have to use $foreach since % pattern subst rules only replace 1x
+OBJS = $(foreach piece, $(BSP_FILES), $(wildcard ../$(piece)/$(ARCH)/*.o)) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/shared/*/$(ARCH)/*.o) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/mongoosev/*/$(ARCH)/*.o) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/$(ARCH)/*.o) \
+    $(foreach piece, $(GENERIC_FILES), ../../../$(piece)/$(ARCH)/$(piece).rel)
+
+LIB = $(ARCH)/libbsp.a
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(LIB): ${OBJS}
+	$(make-library)
+
+$(PROJECT_RELEASE)/lib/libbsp$(LIB_VARIANT).a: $(LIB)
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/libbsp$(LIB_VARIANT).a
+
+all-local: ${ARCH} $(TMPINSTALL_FILES)
+
+include $(top_srcdir)/../../../../../../automake/local.am
